# TP Swing 3 : JTable


Ce TP porte sur l'utilisation du MVC par les objets de Swing.

## Exercice 1

Écrire un programme graphique avec deux champs : un `JTextArea` et un champ texte simple (et non éditable).

En utilisant le `Document` associé au `JTextArea,`
faites en sorte que le champ texte simple affiche en permanence le
nombre de caractères tapés dans le `JTextArea.`

## Exercice 2

On veut saisir les notes des étudiants au partiel et à l'examen, et pouvoir 
voir leur moyenne.

Pour cela, on a créé la classe `Etudiant.` Un étudiant a un nom, un prénom, et deux notes (partiel et examen).

### Question 1
Créer un `TableModel` capable **d'afficher** les données d'une `ArrayList` d'étudiants (pour chaque étudiant : nom, prénom, et ses deux notes).

### Question 1 bis
Écrire un petit programme java qui affichera une `JTable` montrant les notes d'une suite d'étudiants.

### Question 2

- quel est le meilleur endroit, dans l'architecture actuelle, pour calculer la moyenne de l'étudiant à ses deux examens ?
- Ajouter au `JTable` une colonne qui donnera la moyenne de l'étudiant à ses deux examens ;

### Question 3

Rendre éditables les deux notes (examen et partiel). Vérifier que, quand on les modifie, *la moyenne est correctement affichée.*

### Question 4

En bas de l'interface graphique, on trouve un petit formulaire qui permet de saisir le nom et le prénom d'un nouvel étudiant. Rendre actif ce formulaire pour qu'il permette effectivement d'ajouter un nouvel étudiant.



